Module java.base
Package java.lang.reflect

# Class InvocationTargetException

java.lang.Object
java.lang.Throwable
java.lang.Exception
java.lang.ReflectiveOperationException
java.lang.reflect.InvocationTargetException

All Implemented Interfaces:
  `Serializable`

public class InvocationTargetException extends ReflectiveOperationException
InvocationTargetException is a checked exception that wraps an exception thrown by an invoked method or constructor.

As of release 1.4, this exception has been retrofitted to conform to the general purpose exception-chaining mechanism. The "target exception" that is provided at construction time and accessed via the `getTargetException()` method is now known as the cause, and may be accessed via the `Throwable.getCause()` method, as well as the aforementioned "legacy method."

Since:
  1.1
See Also:
  `Method`, `Constructor`, Serialized Form

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`InvocationTargetException()`
Constructs an `InvocationTargetException` with `null` as the target exception.
``
`InvocationTargetException​(Throwable target)`
Constructs a InvocationTargetException with a target exception.
``
`InvocationTargetException​(Throwable target, String s)`
Constructs a InvocationTargetException with a target exception and a detail message.

## Method Summary

Modifier and Type
Method
Description
`Throwable`
`getCause()`
Returns the cause of this exception (the thrown target exception, which may be `null`).
`Throwable`
`getTargetException()`
Get the thrown target exception.

### Methods declared in class java.lang.Throwable

`addSuppressed, fillInStackTrace, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

### Methods declared in class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### InvocationTargetException

protected InvocationTargetException()
Constructs an `InvocationTargetException` with `null` as the target exception.

### InvocationTargetException

public InvocationTargetException​(Throwable target)
Constructs a InvocationTargetException with a target exception.

Parameters:
  `target` - the target exception

### InvocationTargetException

public InvocationTargetException​(Throwable target, String s)
Constructs a InvocationTargetException with a target exception and a detail message.

Parameters:
  `target` - the target exception
  `s` - the detail message

## Method Details

### getTargetException

public Throwable getTargetException()
Get the thrown target exception.

This method predates the general-purpose exception chaining facility. The `Throwable.getCause()` method is now the preferred means of obtaining this information.

Returns:
  the thrown target exception (cause of this exception).

### getCause

public Throwable getCause()
Returns the cause of this exception (the thrown target exception, which may be `null`).

Overrides:
  `getCause` in class `Throwable`
Returns:
  the cause of this exception.
Since:
  1.4